'--------------------------   --------------------------------                                                                   
Declare  SHOW_SYSTEM_VARIABLES = OFF   '    Proteus    
Declare  FSR_CONTEXT_SAVE = OFF        '       FSR
Declare  Reminders = OFF               '    
Declare  Warnings = OFF                '    
Declare  Optimiser_Level 0             '                                                                       
;--------------------------  ------------------------------------                                                                   
Device = 16F628A            '  
Xtal = 4                    '    4 
Declare PortB_Pullups = On          '     PORTB
Declare  All_Digital = On   '     /                                                                   
'--------------------------   --------------------                                                                   
Config  MCLRE_OFF, INTRC_OSC_NOCLKOUT , WDT_OFF , PWRTE_ON , BODEN_OFF , LVP_OFF, CP_OFF 
PORTA=%00000000 '   
PORTB=%00000001 '                                                                   
'--------------------------    ------------------------
'   NOKIA_3310_LCD 1 vdd; 2 sclk; 3 sda; 4 d/c; 5 cs; 6 gnd; 7 Vout; 8 rst ( 5    )
Symbol Lcd_RST=PORTB.1    ' pin 8
Symbol Lcd_DC =PORTB.2    ' pin 4 
Symbol Lcd_SDA=PORTB.3    ' pin 3
Symbol Lcd_CLK=PORTB.4    ' pin 2

Dim x             As Byte '      
Dim y             As Byte '      Y
Dim i             As Byte '    
Dim j             As Word '     LData
Dim k             As Byte '      LData
Dim PosX          As Byte '    
Dim PosY          As Byte '    Y
Dim Lcd_Data      As Byte '      
Dim FontCache[12] As Byte '       LData
Dim Font          As Word '     0...9
Dim cif           As Byte '           
Dim zastavka      As Byte 
Dim PULS          As Byte                                                                          
'--------------------------  TMR1   --------------------
'----------------------------  -----------------------------------------
GoSub Lcd_Init   '    
DelayMS 10 
GoSub Lcd_Clear  '    
DelayMS 10       '  50
'======================  ====================
x=46
For zastavka=0 To 2
    cif=0 
    x=x-13
    y=0
    GoSub READ_Data
Next zastavka
DelayMS 500

'--------------------------   -------------------------------
 PULS=152                          ' 

Main:

Inc PULS
DelayMS 500

GoSub Lcd_Home 
    cif= Dig PULS, 0
    x=33: y=0
    GoSub READ_Data
        cif= Dig PULS,1
        x=20: y=0
        GoSub READ_Data
            cif= Dig PULS,2
            x=7: y=0
            If cif=0 Then cif=10
            GoSub READ_Data
MainEnd:
GoTo Main

'==================================   ====================================
Lcd_Init:
Low Lcd_RST    '    0
DelayMS 20     '  20
High Lcd_RST   '    1
Low Lcd_DC     '     0,   1 (  pin 5  Low Lcd_CS -   0,    1)
  Lcd_Data= $21: GoSub Lcd_SentByte		' Function Set ($21 = % 0010 0001) P=0- , V=0- , H=1- 
  Lcd_Data= $d2: GoSub Lcd_SentByte		'Set Vop     (  0  127  01 xxx xxxx)  82 - 01 101 0010
  Lcd_Data= $06: GoSub Lcd_SentByte		'Temperature Control ($06 = 0000 0110)    
  Lcd_Data= $13: GoSub Lcd_SentByte		'Bias System ($13 = 0001 0011)    
  Lcd_Data= $20: GoSub Lcd_SentByte		' Function Set ($20 = % 0010 0000) =0- , V=0- , H=0- 
'  Lcd_Data= $0c: GoSub Lcd_SentByte		' Display Control ($0 = % 0000 1100) D=1, E=0   -  , D=1, E=1   -  
  Lcd_Data= $0d: GoSub Lcd_SentByte		' Display Control ($0 = % 0000 1101) D=1, E=1 -   
Return


'**********     ************
Lcd_SentByte:
  'Low Lcd_CS   pin 5 "  "
  SHOut Lcd_SDA , Lcd_CLK , MsbFirst, [ Lcd_Data ] '      
  'High Lcd_CS   pin 5 "    "
Return
'***************   ******************
Lcd_Clear:
    GoSub Lcd_Home
    'High Lcd_DC '     0,   1
    For i=1 To 204
      Lcd_Data=$FF:GoSub Lcd_SentByte	'   
      Lcd_Data=$FF:GoSub Lcd_SentByte	' , ..        4    i  Byte
      Lcd_Data=$ff:GoSub Lcd_SentByte	'                    
    ;  Lcd_Data=$ff:GoSub Lcd_SentByte	' , ..  
    Next 
Return
'*****  X=0,Y=0   *****
Lcd_Home:
  PosX=0:PosY=0:GoSub Lcd_GotoXY
Return
'****     ,  ****
Lcd_GotoXY:
  Low Lcd_DC  '     0    
  Lcd_Data=%01000000 | PosY :GoSub Lcd_SentByte	'Y
  Lcd_Data=%10000000 | PosX :GoSub Lcd_SentByte	'X
  High Lcd_DC '   1
Return

'=========      ==========
READ_Data:
Font=LookUpL cif, [0, 48, 96, 144, 192, 240, 288, 336, 384 ,432, 480]
For j=0 To 47 Step 12                                 '    LData
       Inc y                                          '    Y   
           PosX=x:PosY=y:GoSub Lcd_GotoXY
                 For k=0 To 11                        '    LData  0  11 (12)
                     Lcd_Data=LRead8 Font0 [Font+j+k] '  LData   (Font+j+k) 
                     FontCache[k]=~Lcd_Data            '   
                 Next k
   SHOut Lcd_SDA , Lcd_CLK , MsbFirst, [ FontCache[0],FontCache[1],FontCache[2],FontCache[3],FontCache[4],FontCache[5],FontCache[6],FontCache[7],FontCache[8],FontCache[9],FontCache[10],FontCache[11] ]
       If y=4 Then y=0
Next j
Return 

'=============================================================================
Font0:
LData $00,$f8,$fc,$02,$03,$03,$03,$03,$02,$fc,$f8,$00 '  0
LData $00,$3f,$7f,$00,$00,$00,$00,$00,$00,$7f,$3f,$00
LData $00,$fc,$fe,$00,$00,$00,$00,$00,$00,$fe,$fc,$00
LData $00,$1f,$3f,$40,$c0,$c0,$c0,$c0,$40,$3f,$1f,$00 ' 47
'Font1:
LData $00,$00,$00,$00,$00,$00,$00,$00,$00,$fc,$f8,$00 '  1
LData $00,$00,$00,$00,$00,$00,$00,$00,$00,$7f,$3f,$00
LData $00,$00,$00,$00,$00,$00,$00,$00,$00,$fe,$fc,$00
LData $00,$00,$00,$00,$00,$00,$00,$00,$00,$3f,$1f,$00 ' 95
'Font2:
LData $00,$00,$00,$02,$03,$03,$03,$03,$02,$fc,$f8,$00 '  2
LData $00,$00,$00,$80,$80,$80,$80,$80,$80,$7f,$3f,$00
LData $00,$fc,$fe,$01,$01,$01,$01,$01,$01,$00,$00,$00
LData $00,$1f,$3f,$40,$c0,$c0,$c0,$c0,$40,$00,$00,$00 ' 143
'Font3:
LData $00,$00,$00,$02,$03,$03,$03,$03,$02,$fc,$f8,$00 '  3
LData $00,$00,$00,$80,$80,$80,$80,$80,$80,$7f,$3f,$00
LData $00,$00,$00,$01,$01,$01,$01,$01,$01,$fe,$fc,$00
LData $00,$00,$00,$40,$c0,$c0,$c0,$c0,$40,$3f,$1f,$00 ' 191
'Font4:
LData $00,$f8,$fc,$00,$00,$00,$00,$00,$00,$fc,$f8,$00 '  4
LData $00,$3f,$7f,$80,$80,$80,$80,$80,$80,$7f,$3f,$00
LData $00,$00,$00,$01,$01,$01,$01,$01,$01,$fe,$fc,$00
LData $00,$00,$00,$00,$00,$00,$00,$00,$00,$3f,$1f,$00 ' 239
'Font5:
LData $00,$f8,$fc,$02,$03,$03,$03,$03,$02,$00,$00,$00 '  5
LData $00,$3f,$7f,$80,$80,$80,$80,$80,$80,$00,$00,$00
LData $00,$00,$00,$01,$01,$01,$01,$01,$01,$fe,$fc,$00
LData $00,$00,$00,$40,$c0,$c0,$c0,$c0,$40,$3f,$1f,$00 ' 287
'Font6:
LData $00,$f8,$fc,$02,$03,$03,$03,$03,$02,$00,$00,$00 '  6
LData $00,$3f,$7f,$80,$80,$80,$80,$80,$80,$00,$00,$00
LData $00,$fc,$fe,$01,$01,$01,$01,$01,$01,$fe,$fc,$00
LData $00,$1f,$3f,$40,$c0,$c0,$c0,$c0,$40,$3f,$1f,$00 ' 335 
'Font7:
LData $00,$00,$00,$02,$03,$03,$03,$03,$02,$fc,$f8,$00 '  7
LData $00,$00,$00,$00,$00,$00,$00,$00,$00,$7f,$3f,$00
LData $00,$00,$00,$00,$00,$00,$00,$00,$00,$fe,$fc,$00
LData $00,$00,$00,$00,$00,$00,$00,$00,$00,$3f,$1f,$00 ' 383
'Font8:
LData $00,$f8,$fc,$02,$03,$03,$03,$03,$02,$fc,$f8,$00 '  8
LData $00,$3f,$7f,$80,$80,$80,$80,$80,$80,$7f,$3f,$00
LData $00,$fc,$fe,$01,$01,$01,$01,$01,$01,$fe,$fc,$00
LData $00,$1f,$3f,$40,$c0,$c0,$c0,$c0,$40,$3f,$1f,$00 ' 431
'Font9:
LData $00,$f8,$fc,$02,$03,$03,$03,$03,$02,$fc,$f8,$00 '  9
LData $00,$3f,$7f,$80,$80,$80,$80,$80,$80,$7f,$3f,$00
LData $00,$00,$00,$01,$01,$01,$01,$01,$01,$fe,$fc,$00
LData $00,$00,$00,$40,$c0,$c0,$c0,$c0,$40,$3f,$1f,$00 ' 479
'Font91:
LData $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 '  
LData $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
LData $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
LData $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 '



